package lcsb.mapviewer.wikipathway.model;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;
import java.util.List;

import org.apache.commons.lang3.SerializationUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;

import lcsb.mapviewer.wikipathway.WikipathwaysTestFunctions;

public class ShapeTest extends WikipathwaysTestFunctions {

  Logger logger = LogManager.getLogger();

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testSeialization() {
    SerializationUtils.serialize(new Shape());
  }

  @Test
  public void getNameForSpecialShapes() {
    List<String> specialShapeNames = Arrays.asList("Sarcoplasmic Reticulum", "Golgi Apparatus", "Endoplasmic Reticulum",
        "Mitochondria");
    for (String string : specialShapeNames) {
      Shape shape = new Shape();
      shape.setShape(string);
      assertEquals(string, shape.getName());
      shape.setTextLabel("bla");
      assertTrue(shape.getName().contains(string));
    }
  }

  @Test
  public void getNameForGenericShapes() {
    List<String> otherShapes = Arrays.asList("Rectangle", "Triangle", "Oval");
    for (String string : otherShapes) {
      Shape shape = new Shape();
      shape.setShape(string);
      assertTrue(shape.getName().isEmpty());
      shape.setTextLabel("bla");
      assertEquals("bla", shape.getName());
    }
  }

}
