package lcsb.mapviewer.services.search.chemical;

import static org.mockito.ArgumentMatchers.anyString;

import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.*;

import lcsb.mapviewer.annotation.services.dapi.*;

@Profile("ctdTestProfile")
@Configuration
public class CtdDapiConfiguration {

  @Autowired
  private DapiConnector dapiConnector;

  private String dapiLogin;
  private String dapiPassword;

  public CtdDapiConfiguration() {
    dapiLogin = System.getenv("DAPI_TEST_LOGIN");
    dapiPassword = System.getenv("DAPI_TEST_PASSWORD");
  }

  @Bean
  @Primary
  public DapiConnector dapiConnector() throws DapiConnectionException {
    DapiConnectorImpl mock = (DapiConnectorImpl) Mockito.spy(dapiConnector);

    Mockito.doReturn("https://dapi.lcsb.uni.lu/api/database/CTD/releases/2019.02/").when(mock)
        .getLatestReleaseUrl(anyString());

    Mockito.doReturn(true).when(mock).isValidConnection();

    Mockito.doReturn(dapiLogin).when(mock).getDapiLogin();
    Mockito.doReturn(dapiPassword).when(mock).getDapiPassword();
    return mock;
  }

}
