package lcsb.mapviewer.services.search.chemical;

import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.*;

import lcsb.mapviewer.annotation.services.dapi.*;

@Profile("dapiUnavailableTestProfile")
@Configuration
public class DapiUnavailableConfiguration {

  @Autowired
  private DapiConnector dapiConnector;

  public DapiUnavailableConfiguration() {
  }

  @Bean
  @Primary
  public DapiConnector dapiConnector() throws DapiConnectionException {
    DapiConnectorImpl mock = (DapiConnectorImpl) Mockito.spy(dapiConnector);

    Mockito.doReturn(false).when(mock).isValidConnection();

    Mockito.doReturn("").when(mock).getDapiLogin();
    Mockito.doReturn("").when(mock).getDapiPassword();
    return mock;
  }

}
